<?php
if (!defined('DC_RC_PATH')) { return; }

/* Add behavior for the checkbox in the admin preferences */
$core->addBehavior('adminBlogPreferencesForm',array('publicCDN','adminBlogPreferencesForm'));
$core->addBehavior('adminBeforeBlogSettingsUpdate',array('publicCDN','adminBeforeBlogSettingsUpdate'));

class publicCDN {
	public static function adminBlogPreferencesForm($core,$settings)
	{
		echo
		'<fieldset><legend>publicCDN</legend>'.
		'<p><label class="classic">'.form::checkbox('cdn_enabled',1,$settings->publiccdn->cdn_enabled).
		__('Enable the rerouting of every request to the public directory through a CDN.')."</label></p>\n".
		'<p><label class="classic">'.
		__('Reroute every request to the public directory through this CDN:')."\n".
		form::field('cdn_url',60,255,$settings->publiccdn->cdn_url)."</label></p>\n".
		'</fieldset>';
	}
	
	public static function adminBeforeBlogSettingsUpdate($settings)
	{
		$settings->addNameSpace('publiccdn');
    $settings->publiccdn->put('cdn_enabled',!empty($_POST['cdn_enabled']),'boolean','Activate the redirection through a <abbr title="Content Delivery Network">CDN</abbr>');
		$settings->publiccdn->put('cdn_url',$_POST['cdn_url'],'string','Base URL for the <abbr title="Content Delivery Network">CDN</abbr>');
	}

}
?>
