<?php
if (!defined('DC_RC_PATH')) { return; }

/* Add behavior callback, will be used for all types of posts (standard, page, galery item, ...) */
$core->addBehavior('publicAfterContentFilter',array('tplPublicCDN','afterContentFilter'));

class tplPublicCDN {
	protected static $callback_re;
	protected static $callback_subst;

	public static function afterContentFilter($core, $tag, $args) {
		if (!$core->blog->settings->publiccdn->cdn_enabled || ($tag != 'EntryContent' && substr($tag, -3) != 'URL')) {
			return;
		}
#		myLog::log('Calling afterContentFilter; tag: ' . $tag);
#		myLog::log('url type: ' . $core->url->type);
#		myLog::log('Args: '.print_r($args, true));

		#	Construct a regexp matching the public URL, whether it's absolute or not
		$public_url_re = '(?:[a-zA-Z]{3,}://[^/]+)?'.$core->blog->settings->system->public_url;

		$str =& $args[0];
#		myLog::log('matching on '.$str);
		if ($tag == 'EntryContent') {
			# Look for URL in the following attributes
			$attr = 'action|background|cite|classid|codebase|data|href|longdesc|profile|src|usemap';
			# Construct the regexp for URLs in the attributes value (whether where in quoted HTML or not)
			$post_public_re = '#(?:('.$attr.')=)(:?"|&quot;)('.$public_url_re.')(.+?)(?:"|&quot;)#msu';
			self::$callback_re = '#(:?"|&quot;)'.$public_url_re.'([^"]+?)(?:"|&quot)#msu';
			self::$callback_subst = '"'.$core->blog->settings->publiccdn->cdn_url . '$2"';
		} else {
			$post_public_re = '#'.$public_url_re.'(.+)#msu';
			self::$callback_re = '#'.$public_url_re.'(.+)#msu';
			self::$callback_subst = $core->blog->settings->publiccdn->cdn_url . '$1';
		}
#		myLog::log('matching regexp: '.$post_public_re);

		// Find every public link
		if (preg_match_all($post_public_re,$str,$m) > 0) {
#			myLog::log('Found match');
			// Add the CDN URL to each one
			$str = preg_replace_callback($post_public_re, array('self', 'switchCDN'), $str);
		}
	}

	protected static function switchCDN($match)
	{
		global $core;
#		myLog::log('Replacing in: '.$match[0]);
		$s = preg_replace(self::$callback_re, self::$callback_subst, $match[0]);
		return $s;
	}

}
?>
